#ifdef OPENGL_ES
#extension GL_OES_standard_derivatives : enable
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#else
precision mediump float;
#endif

///////////////////////////////////////////////////////////
// Uniforms
uniform float u_time;
uniform vec3 u_resolution;	// ӁIdlIvec2Ȃ̂vec3őp
///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;

void main()
{
	//  ʒ̍Wɕϊ 1280:720Ȃ̂ x:-1.777778~1.777778 y:-1.0~1.0
	vec2 p = (gl_FragCoord.xy * 2.0 - u_resolution.xy) / u_resolution.y;

	// oߎԂɂF̕ω
	float t = u_time * 1.5;
	float r = sin(t);
	float g = cos(t);
	float b = atan(r, g);

	float f = 0.0;

	for (int i = 0; i < 8; ++i) {
		// ItZbg
		float t = u_time * -(float(i) + 1.0);
		float x = cos(t) * 0.7;
		float y = sin(t) * 0.7;
		// TCY
		f += 0.05 / length(p + vec2(x, y));
	}

	// ͂Â
	vec2 m = v_texCoord * 2.0 - 1.0;
	vec2 o = abs(m.yx) / vec2(6.0, 4.0);
	m += m * o * o;
	m = abs(m);
	m.x = pow(m.x, 15.0);
	m.y = pow(m.y, 15.0);
	r = mix(abs(r), 0.0, m.x + m.y);
	g = mix(abs(g), 0.0, m.x + m.y);
	b = mix(abs(b), 0.0, m.x + m.y);

	gl_FragColor = vec4(vec3(f) * vec3(r, g, b), 1.0);
}
